<template>
	<b-modal id="new-email-modal" size="xl" scrollable centered hide-footer
			 title="New message">
		<b-form @submit.prevent="send">
			<b-form-group
				id="recipient-grp"
				label="To"
				label-for="recipient"
				description="Example: admin@[192.168.1.1]">
				<b-form-input
					required
					id="recipient"
					v-model="message.recipient_username"
					autocomplete="email"
					:disabled="busy"/>
			</b-form-group>
			<b-form-group
				id="subject-grp"
				label="Subject"
				label-for="subject">
				<b-form-input
					required
					id="subject"
					v-model="message.subject"
					:disabled="busy"/>
			</b-form-group>
			<b-form-group
				id="text-grp"
				label="Text"
				label-for="text"
				description="Supports HTML!">
				<b-form-textarea
					required
					id="text"
					v-model="message.text"
					rows="5"
					:disabled="busy"/>
			</b-form-group>
			<transition name="fade">
				<b-spinner v-if="busy" class="mt-1" variant="success" label="Loading..."/>
			</transition>
			<b-button variant="outline-custom-dark" type="submit" class="float-right" :disabled="busy">
				Send!
			</b-button>
		</b-form>
	</b-modal>
</template>

<script>
import {errorJsonToToast,} from '@/utils';

export default {
	name: 'NewEmailModal',
	data() {
		return {
			message: {},
			busy: false,
		};
	},
	methods: {
		send() {
			const data = this.message;
			console.debug('Sending email', data);
			this.busy = true;

			this.$http.post('/messages/', data)
				.then(r => {
					this.busy = false;
					this.message = {};
					const data = r.data;
					console.info('Mail successfully sent!', data);
					this.$emit('email-sent');
					this.$bvModal.hide('new-email-modal');
					this.$nextTick(() => {
						this.$bvToast.toast('Email sent!', {
							title: 'Success',
							variant: 'success',
						});
					});
				})
				.catch(e => {
					this.busy = false;
					console.error('Failed to send message', e);
					this.$bvToast.toast(errorJsonToToast(this, e), {
						title: 'Failed to send message',
						variant: 'danger',
					});
				});
		},
	},
};
</script>

<style scoped>

</style>
